eval " use ReDIF::Parser::Input; ";

test( not( $@ ), $@ );

use ReDIF::Parser::Input;

my $r;

$r = ReDIF::Parser::Input::start_file( 't/ctlseri.rdf', 0 );

test($r);

my $l = length( $ReDIF::Parser::Input::BUFFER );

$r = ReDIF::Parser::Input::get_more_data_to_the_buffer2();
test($r);

my $l2 = length( $ReDIF::Parser::Input::BUFFER );
test( ($l < $l2 ) );

while( $r ) {
    $r = ReDIF::Parser::Input::get_more_data_to_the_buffer2();
}

$l = length( $ReDIF::Parser::Input::BUFFER );

test( ($l > $l2 ) );



for( my $in=0; $in < 8 ; $in ++ ) {
    $r = ReDIF::Parser::Input::extract_next_line_self_sufficient();
    
}
$line = ReDIF::Parser::Input::get_the_line( );
$line_length = ReDIF::Parser::Input::get_the_line_length( );

test( $line, $line );
test( $line_length, $line_length );


$r = ReDIF::Parser::Input::start_file( 't/ctlseri.rdf', 114 );

test($r);

$r = ReDIF::Parser::Input::extract_next_attribute();

if( $r ) {
    print $r->{attribute}, "\n";
    print $r->{value}, "\n";
    print $r->{file_position}, "\n";
#    print $r->{line_number}, "\n";

}



###############################################################
#############     TESTING   FRAMEWORK     #####################
###############################################################

sub test {
    push @TESTS, shift;
    push @MESSAGES, shift;
}

sub ok { 
    push @TESTS, 1; 
    push @MESSAGES, shift;
}
sub nok { 
    push @TESTS, 0; 
    push @MESSAGES, shift;
}



END { 

    my $tests = scalar @TESTS;

    if( not $tests ) {
	print "1..1\nnot ok 1\n";
	exit;
    }

    print "1..$tests\n";

    my $counter = 1;
    while ( 1 ) {
	my $t = shift @TESTS;
	my $m = shift @MESSAGES;
	if( not $t ) {
	    print "not ";
	}
	print "ok $counter\n";

	if( $m ) { 
	    print "[$counter] $m\n";
	}
	last if not scalar @TESTS;
	$counter ++;
    }
}
